<xsl:stylesheet version="2.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" 
    xmlns:xalan="http://xml.apache.org/xalan" 
    xmlns:functx="http://www.functx.com"
    xmlns="urn:schemas-microsoft-com:office:excel"
    >
    
    
	<xsl:param name="includedFile"/>
	<xsl:output method="xml" version="1.0"  encoding="UTF-8" indent="yes" omit-xml-declaration="no"/>
	
	<!--COPY NODES AND STRUCTURES (identical transformation)-->
	<xsl:template match="@*|node()">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()"/>
		</xsl:copy>
	</xsl:template>
	    
		<xsl:template name="insertDefaultStyle">
						<xsl:text disable-output-escaping="yes">
   &lt;Style  xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="Default" &gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders/&gt;
   &lt;Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#000000"/&gt;
   &lt;Interior /&gt;
   &lt;NumberFormat ss:Format="@" /&gt;
   &lt;Protection/&gt;
  &lt;/Style&gt;
		</xsl:text>
	</xsl:template>	

	<xsl:template name="insertStyle">
						<xsl:text disable-output-escaping="yes">
&lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLEHIDDEN"&gt;
   &lt;Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#A5A5A5"/&gt;
  &lt;/Style&gt;	
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLEProjectDocumentation"&gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders&gt;
    &lt;Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
   &lt;/Borders&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Bold="1"/&gt;
   &lt;/Style&gt;					
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLEProjectDocumentationUnprotected"&gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders&gt;
    &lt;Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
   &lt;/Borders&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Bold="1"/&gt;
   &lt;Protection ss:Protected="0"/&gt;   
   &lt;/Style&gt;		
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE1"&gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders&gt;
    &lt;Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
   &lt;/Borders&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Bold="1"/&gt;
   &lt;Interior ss:Color="#FFCC99" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE1_Required" ss:Parent="UABSTYLE1"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE2" ss:Parent="UABSTYLE1"&gt;
   &lt;Interior ss:Color="#FFFF99" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE2_Required" ss:Parent="UABSTYLE2"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;  
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE3" ss:Parent="UABSTYLE1"&gt;
   &lt;Interior ss:Color="#CCFFCC" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE3_Required" ss:Parent="UABSTYLE3"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;  
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE4" ss:Parent="UABSTYLE1"&gt;
   &lt;Interior ss:Color="#CCFFFF" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE4_Required" ss:Parent="UABSTYLE4"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;  
    &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE5" ss:Parent="UABSTYLE1"&gt;
   &lt;Interior ss:Color="#99CCFF" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
    &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE5_Required" ss:Parent="UABSTYLE5"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;  
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UnprotectedUABSTYLE"&gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders/&gt;
   &lt;Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#000000"/&gt;
   &lt;Interior/&gt;   
   &lt;NumberFormat ss:Format="@"/&gt;
   &lt;Protection ss:Protected="0"/&gt;   
  &lt;/Style&gt;  
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="HyperlinkUABSTYLE"&gt;
   &lt;Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#0000FF" ss:Underline="Single"/&gt;
  &lt;/Style&gt;  
&lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="s30UABSTYLE"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss"/&gt;
  &lt;/Style&gt;
<!-- Add Left-aligned styles for UCPCSpecDoc documentation sheet -->
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE1" ss:Parent="UABSTYLE1"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE1_Required" ss:Parent="UABSTYLE1_Required"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE2" ss:Parent="UABSTYLE2"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE2_Required" ss:Parent="UABSTYLE2_Required"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE3" ss:Parent="UABSTYLE3"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE3_Required" ss:Parent="UABSTYLE3_Required"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE4" ss:Parent="UABSTYLE4"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE4_Required" ss:Parent="UABSTYLE4_Required"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE5" ss:Parent="UABSTYLE5"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="LeftUABSTYLE5_Required" ss:Parent="UABSTYLE5_Required"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UnprotectedLeftUABSTYLE" ss:Parent="UnprotectedUABSTYLE"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="s30LeftUABSTYLE" ss:Parent="s30UABSTYLE"&gt;
   &lt;Alignment ss:Horizontal="Left" ss:Vertical="Top" ss:WrapText="1"/&gt;
   &lt;Borders&gt;
    &lt;Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
   &lt;/Borders&gt;
  &lt;/Style&gt;
</xsl:text>
	</xsl:template>
	
	<!-- UCPC-627 Add template for replace-substring per Ivan -->
	<xsl:template name="replace-substring">
		<xsl:param name="original"/>
		<xsl:param name="substring"/>
		<xsl:param name="replacement" select="''"/>
		<xsl:choose>
			<xsl:when test="contains($original, $substring)">
				<xsl:value-of select="substring-before($original, $substring)"/>
				<xsl:value-of select="$replacement"/>
				<xsl:call-template name="replace-substring">
					<xsl:with-param name="original" select="substring-after($original, $substring)"/>
					<xsl:with-param name="substring" select="$substring"/>
					<xsl:with-param name="replacement" select="$replacement"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$original"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<xsl:template match="/">
		<xsl:variable name="included">
			<xsl:if test="$includedFile!=''">
				<xsl:copy-of select="document($includedFile)"/>
			</xsl:if>
		</xsl:variable>
		
		<!-- Gets the row number where the device header table starts -->
		<xsl:variable name="header-start">		
		  <xsl:for-each select="//Information">
			   <xsl:copy-of select="count(child::*)+2"/>
			</xsl:for-each>
		</xsl:variable>			
		
		<xsl:text disable-output-escaping="yes">
&lt;?mso-application progid="Excel.Sheet"?&gt;
&lt;Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
 xmlns:o="urn:schemas-microsoft-com:office:office"
 xmlns:x="urn:schemas-microsoft-com:office:excel"
 xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
 xmlns:html="http://www.w3.org/TR/REC-html40"&gt;
 &lt;DocumentProperties xmlns="urn:schemas-microsoft-com:office:office"&gt;
  &lt;Author&gt;dmitrif&lt;/Author&gt;
  &lt;LastAuthor&gt;iprietob&lt;/LastAuthor&gt;
  &lt;Created&gt;2009-05-04T16:42:08Z&lt;/Created&gt;
  &lt;LastSaved&gt;2009-05-05T09:22:31Z&lt;/LastSaved&gt;
  &lt;Company&gt;CERN&lt;/Company&gt;
  &lt;Version&gt;11.9999&lt;/Version&gt;
 &lt;/DocumentProperties&gt;
 &lt;ExcelWorkbook xmlns="urn:schemas-microsoft-com:office:excel"&gt;
  &lt;WindowHeight&gt;12660&lt;/WindowHeight&gt;
  &lt;WindowWidth&gt;19020&lt;/WindowWidth&gt;
  &lt;WindowTopX&gt;120&lt;/WindowTopX&gt;
  &lt;WindowTopY&gt;105&lt;/WindowTopY&gt;
  &lt;ProtectStructure&gt;False&lt;/ProtectStructure&gt;
  &lt;ProtectWindows&gt;False&lt;/ProtectWindows&gt;
 &lt;/ExcelWorkbook&gt;
  &lt;Styles&gt;
 </xsl:text>
 <xsl:if test="$includedFile!=''"><!--COPY STYLES FROM FILE TO BE INCLUDED (but the default style) -->
 		<xsl:for-each select="xalan:nodeset($included)//*[name()='Style'][@ss:ID != 'Default']">
			<xsl:copy>
				<xsl:apply-templates select="@*|node()"/>
			</xsl:copy>
		</xsl:for-each>
		<!-- Add the default style -->
		<xsl:call-template name="insertDefaultStyle"/>
</xsl:if>
<!--CREATE DEFAULT STYLE-->
 <xsl:if test="$includedFile=''">
			<xsl:call-template name="insertDefaultStyle"/>
			<xsl:call-template name="insertStyle"/>
</xsl:if>
		<!--check if we already have UAB styles (it could be if file to include was generated using this xslt)-->
		<xsl:if test="$includedFile!=''">
			<xsl:if test="count(xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE1']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE2']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE3']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE4']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE5']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='s30UABSTYLE'])=0">
				<xsl:call-template name="insertStyle"/>
			</xsl:if>
		</xsl:if>	
		
<xsl:text disable-output-escaping="yes">&lt;/Styles&gt;</xsl:text>
	
<!--Create Named Ranges (UCPC-635)-->

<xsl:text disable-output-escaping="yes">&#10;&lt;Names&gt;</xsl:text>

	<!-- UCPC-635 Create Named Ranges for each Attribute -->
	<!-- Format is: 
	<NamedRange ss:Name="UCPCSpecDoc_AttributeFamily_[AttributeName_]AttributeName" ss:RefersTo="=AttributeDocumentation!R2C1"/>
	-->
	<xsl:for-each select="UNICOSMetaModel/AttributeFamily[count(//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>0]">
		<xsl:for-each select=".//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0]">
		<xsl:variable name="row" select="count(.//preceding::Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0] )*4 + 2"/>
		<xsl:text disable-output-escaping="yes">
	&lt;NamedRange ss:Name="UCPCSpecDoc_</xsl:text>
	<xsl:value-of select="ancestor::AttributeFamily/AttributeFamilyName"/><xsl:text disable-output-escaping="yes">_</xsl:text>
	<xsl:choose>
		<xsl:when test="count(ancestor::Attribute/AttributeName)>0"><xsl:value-of select="ancestor::Attribute/AttributeName"/><xsl:text disable-output-escaping="yes">_</xsl:text></xsl:when>
	</xsl:choose>
	<!--Remove spaces from AttributeName, just in case there are any -->
	<xsl:variable name="AttributeNameNoSpaces" >
		<xsl:call-template name="replace-substring">
			<xsl:with-param name="original" select="AttributeName"/>
			<xsl:with-param name="substring" select="' '"/>
			<xsl:with-param name="replacement" select="''"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:value-of select="$AttributeNameNoSpaces"/>
	<xsl:text disable-output-escaping="yes">" ss:RefersTo="=UCPCSpecDoc!R</xsl:text><xsl:value-of select="$row"/><xsl:text disable-output-escaping="yes">C2"/&gt;</xsl:text>
	</xsl:for-each>
	</xsl:for-each>

<xsl:text disable-output-escaping="yes">&#10;&lt;/Names&gt;</xsl:text>
		
<xsl:if test="$includedFile=''"><!--If creating new workbook, add Title Page-->
                        <xsl:text disable-output-escaping="yes"><![CDATA[ 
                        <Worksheet xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:Protected="1" ss:Name="ProjectDocumentation">
	 <Table ss:ExpandedColumnCount="5" x:FullColumns="1"
   x:FullRows="1" ss:DefaultRowHeight="15" ss:HeaderStart="9" ss:HeaderEnd="9" ss:StyleID="UnprotectedUABSTYLE" >
   <Column ss:Width="120.75"/>
   <Column ss:AutoFitWidth="0" ss:Width="90.75"/>
   <Column ss:AutoFitWidth="0" ss:Width="282"/>
   <Column ss:AutoFitWidth="0" ss:Width="60.75"/>
   <Column ss:AutoFitWidth="0" ss:Width="61.5"/>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Project Name:</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentationUnprotected" ss:MergeAcross="3"><Data ss:Type="String"></Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Application Name:</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentationUnprotected" ss:MergeAcross="3"><Data ss:Type="String"></Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Project Description:</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentationUnprotected" ss:MergeAcross="3"><Data ss:Type="String"></Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Project Owner:</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentationUnprotected" ss:MergeAcross="3"><Data ss:Type="String"></Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Spec FAQ link:</Data></Cell>
    <Cell ss:MergeAcross="3" ss:StyleID="UABSTYLEProjectDocumentation" ss:HRef="http://cern.ch/UNICOS-SpecFAQ"><Data
      ss:Type="String">http://cern.ch/UNICOS-SpecFAQ</Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Object Descriptions link:</Data></Cell>
    <Cell ss:MergeAcross="3" ss:StyleID="UABSTYLEProjectDocumentation" ss:HRef="http://cern.ch/UNICOS-ObjectDescription"><Data
      ss:Type="String">http://cern.ch/UNICOS-ObjectDescription</Data></Cell>
   </Row>
   <Row/>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Spec Changes:</Data></Cell>
    <Cell ss:MergeAcross="3" />
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Date</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">User</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Comments</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Version</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">HTML link</Data></Cell>
   </Row>
  </Table>
  <WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel">
   <PageSetup>
    <Header x:Margin="0.3"/>
    <Footer x:Margin="0.3"/>
    <PageMargins x:Bottom="0.75" x:Left="0.7" x:Right="0.7" x:Top="0.75"/>
   </PageSetup>
   <Unsynced/>
   <Selected/>
   <FreezePanes/>
   <FrozenNoSplit/>
   <SplitHorizontal>9</SplitHorizontal>
   <TopRowBottomPane>9</TopRowBottomPane>
   <SplitVertical>1</SplitVertical>
   <LeftColumnRightPane>1</LeftColumnRightPane>
   <ActivePane>0</ActivePane>
   <Panes>
    <Pane>
     <Number>3</Number>
     <ActiveRow>18</ActiveRow>
     <RangeSelection>R19C1:R20C5</RangeSelection>
    </Pane>
   </Panes>
   <ProtectObjects>False</ProtectObjects>
   <ProtectScenarios>False</ProtectScenarios>
   <AllowSizeCols/>
   <AllowSizeRows/>
   <AllowInsertHyperlinks/>
   <AllowSort/>
   <AllowFilter/>
   <AllowFormatCells/>
  </WorksheetOptions>
 </Worksheet>
   ]]></xsl:text>
            </xsl:if><!--transform current xml-->

	<xsl:if test="$includedFile!=''"><!--copy all the worksheets from file to include-->
		<xsl:for-each select="xalan:nodeset($included)//*[name()='Worksheet']">
			<xsl:copy>
				<xsl:apply-templates select="@*|node()"/>
			</xsl:copy>
		</xsl:for-each>
	</xsl:if><!--transform current xml-->
		<xsl:text disable-output-escaping="yes">&lt;Worksheet xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:Protected="1" ss:Name="UCPCSpecDoc"</xsl:text>
		<!--Hard-code worksheet name to UCPCSpecDoc -->
<!--		<xsl:variable name="currentName"> 
			 <xsl:value-of select="UNICOSMetaModel/Information/Name"/> 
		</xsl:variable> 
		<xsl:if test="$includedFile!=''">
			<xsl:if test="count(xalan:nodeset($included)//*[name()='Worksheet'][@ss:Name=$currentName])>0">
				"<xsl:value-of select="UNICOSMetaModel/Information/Name"/>()"
			</xsl:if>
			<xsl:if test="count(xalan:nodeset($included)//*[name()='Worksheet'][@ss:Name=$currentName])=0">
				"<xsl:value-of select="UNICOSMetaModel/Information/Name"/>"
			</xsl:if>
		</xsl:if>
		<xsl:if test="$includedFile=''">
				"<xsl:value-of select="UNICOSMetaModel/Information/Name"/>"
		</xsl:if>
-->		
		<xsl:variable name="header-max-length">
		  <xsl:for-each select="//isSpecificationAttribute">
			  <xsl:sort select="count(ancestor::*)" data-type="number"/>
			  <xsl:if test="position()=last()">
			   <xsl:copy-of select="count(ancestor::*)"/>
			  </xsl:if>
			</xsl:for-each>
		</xsl:variable>	
		
		<xsl:text disable-output-escaping="yes">&gt;
		
  &lt;Table ss:ExpandedColumnCount="256" x:FullColumns="1"
   x:FullRows="1" ss:HeaderStart="1" ss:HeaderEnd="1" ss:StyleID="UnprotectedLeftUABSTYLE"&gt;
</xsl:text>
<!--Column Definition-->
<xsl:text disable-output-escaping="yes"><![CDATA[
   <Column ss:StyleID="UnprotectedLeftUABSTYLE" ss:Width="129.75"/>
   <Column ss:StyleID="UnprotectedLeftUABSTYLE" ss:Width="241.5"/>
   <Column ss:StyleID="UnprotectedLeftUABSTYLE" ss:Width="77.25"/>
   <Column ss:StyleID="UnprotectedLeftUABSTYLE" ss:Width="600.75"/>
   <Column ss:StyleID="UnprotectedLeftUABSTYLE" ss:Width="99.75" ss:Span="251"/>
]]></xsl:text>
<!--Header Row-->
<xsl:text disable-output-escaping="yes">
    &lt;Row ss:StyleID="s30LeftUABSTYLE"&gt;
    &lt;Cell ss:StyleID="s30LeftUABSTYLE"&gt;&lt;Data ss:Type="String"&gt;AttributeFamily&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30LeftUABSTYLE"&gt;&lt;Data ss:Type="String"&gt;AttributeName&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30LeftUABSTYLE"&gt;&lt;Data ss:Type="String"&gt;HelpCategory&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30LeftUABSTYLE"&gt;&lt;Data ss:Type="String"&gt;HelpDescription&lt;/Data&gt;&lt;/Cell&gt;
    &lt;/Row&gt;
</xsl:text>

		<xsl:for-each select="UNICOSMetaModel/AttributeFamily[count(//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>0]">
			<xsl:variable name="pos">
			<xsl:value-of select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1" />
			</xsl:variable>
			<xsl:for-each select=".//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0]">
				<!-- ************************ DESCRIPTION ROW ************************* --> 
				<xsl:variable name="number_of_CRLF_in_Description">
					<xsl:value-of select="string-length(Description) - string-length(translate(Description, '&#10;', '')) + 1"/>
				</xsl:variable>  
				<xsl:text disable-output-escaping="yes">&lt;Row ss:Height="</xsl:text><xsl:value-of select="12.75*$number_of_CRLF_in_Description"/><xsl:text disable-output-escaping="yes">" ss:StyleID="s30LeftUABSTYLE"&gt;</xsl:text>
				<!--First column: AttributeFamily-->
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="LeftUABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:value-of select="ancestor::AttributeFamily/AttributeFamilyName"/>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End first column: AttributeFamily-->
				<!--Second column: AttributeName-->
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="LeftUABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:choose>
					<xsl:when test="count(ancestor::Attribute/AttributeName)>0">
						<xsl:choose>
							<xsl:when test="count(ancestor::Attribute/isSpecificationAttribute/NameRepresentation)>0">
								<xsl:value-of select="ancestor::Attribute/isSpecificationAttribute/NameRepresentation"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="ancestor::Attribute/AttributeName"/>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:text disable-output-escaping="yes">::</xsl:text>
					</xsl:when>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/NameRepresentation)>0">
						<xsl:value-of select="isSpecificationAttribute/NameRepresentation"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="AttributeName"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End second column: AttributeName-->
				<!--Third column: HelpCategory-->
				<xsl:text disable-output-escaping="yes">&lt;Cell&gt;&lt;Data ss:Type="String"&gt;Description</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End third column: HelpCategory-->
				<!--Fourth column: HelpDescription-->
				<xsl:text disable-output-escaping="yes">&lt;Cell&gt;&lt;Data ss:Type="String"&gt;&lt;![CDATA[</xsl:text>
				<xsl:choose>
					<xsl:when test="count(Description)>0">
						<xsl:value-of disable-output-escaping="yes" select="Description"/>
					</xsl:when>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">]]&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End fourth column: HelpDescription-->
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;&#10;</xsl:text>

				<!-- ************************ USAGE ROW ************************* --> 
				<xsl:variable name="number_of_CRLF_in_Usage">
					<xsl:value-of select="string-length(isSpecificationAttribute/Usage) - string-length(translate(isSpecificationAttribute/Usage, '&#10;', '')) + 1"/>
				</xsl:variable>  
				<xsl:text disable-output-escaping="yes">&lt;Row ss:Height="</xsl:text><xsl:value-of select="12.75*$number_of_CRLF_in_Usage"/><xsl:text disable-output-escaping="yes">" ss:StyleID="s30LeftUABSTYLE"&gt;</xsl:text>
				<!--First column: AttributeFamily-->
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="LeftUABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:value-of select="ancestor::AttributeFamily/AttributeFamilyName"/>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End first column: AttributeFamily-->
				<!--Second column: AttributeName-->
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="LeftUABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:choose>
					<xsl:when test="count(ancestor::Attribute/AttributeName)>0">
						<xsl:choose>
							<xsl:when test="count(ancestor::Attribute/isSpecificationAttribute/NameRepresentation)>0">
								<xsl:value-of select="ancestor::Attribute/isSpecificationAttribute/NameRepresentation"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="ancestor::Attribute/AttributeName"/>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:text disable-output-escaping="yes">::</xsl:text>
					</xsl:when>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/NameRepresentation)>0">
						<xsl:value-of select="isSpecificationAttribute/NameRepresentation"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="AttributeName"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End second column: AttributeName-->
				<!--Third column: HelpCategory-->
				<xsl:text disable-output-escaping="yes">&lt;Cell&gt;&lt;Data ss:Type="String"&gt;Usage</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End third column: HelpCategory-->
				<!--Fourth column: HelpDescription-->
				<xsl:text disable-output-escaping="yes">&lt;Cell&gt;&lt;Data ss:Type="String"&gt;&lt;![CDATA[</xsl:text>
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/Usage)>0">
						<xsl:value-of disable-output-escaping="yes" select="isSpecificationAttribute/Usage"/>
					</xsl:when>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">]]&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End fourth column: HelpDescription-->
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;&#10;</xsl:text>

				<!-- ************************ DEPENDENTATTRIBUTES ROW ************************* --> 
				<xsl:variable name="number_of_CRLF_in_DependentAttributes">
					<xsl:value-of select="string-length(isSpecificationAttribute/DependentAttributes) - string-length(translate(isSpecificationAttribute/DependentAttributes, '&#10;', '')) + 1"/>
				</xsl:variable>  
				<xsl:text disable-output-escaping="yes">&lt;Row ss:Height="</xsl:text><xsl:value-of select="12.75*$number_of_CRLF_in_DependentAttributes"/><xsl:text disable-output-escaping="yes">" ss:StyleID="s30LeftUABSTYLE"&gt;</xsl:text>
				<!--First column: AttributeFamily-->
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="LeftUABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:value-of select="ancestor::AttributeFamily/AttributeFamilyName"/>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End first column: AttributeFamily-->
				<!--Second column: AttributeName-->
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="LeftUABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:choose>
					<xsl:when test="count(ancestor::Attribute/AttributeName)>0">
						<xsl:choose>
							<xsl:when test="count(ancestor::Attribute/isSpecificationAttribute/NameRepresentation)>0">
								<xsl:value-of select="ancestor::Attribute/isSpecificationAttribute/NameRepresentation"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="ancestor::Attribute/AttributeName"/>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:text disable-output-escaping="yes">::</xsl:text>
					</xsl:when>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/NameRepresentation)>0">
						<xsl:value-of select="isSpecificationAttribute/NameRepresentation"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="AttributeName"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End second column: AttributeName-->
				<!--Third column: HelpCategory-->
				<xsl:text disable-output-escaping="yes">&lt;Cell&gt;&lt;Data ss:Type="String"&gt;DependentAttributes</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End third column: HelpCategory-->
				<!--Fourth column: HelpDescription-->
				<xsl:text disable-output-escaping="yes">&lt;Cell&gt;&lt;Data ss:Type="String"&gt;&lt;![CDATA[</xsl:text>
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/DependentAttributes)>0">
						<xsl:value-of disable-output-escaping="yes" select="isSpecificationAttribute/DependentAttributes"/>
					</xsl:when>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">]]&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End fourth column: HelpDescription-->
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;&#10;</xsl:text>

				<!-- ************************ CONSTRAINTS ROW ************************* --> 
				<xsl:variable name="number_of_CRLF_in_Constraints">
					<xsl:value-of select="string-length(isSpecificationAttribute/Constraints) - string-length(translate(isSpecificationAttribute/Constraints, '&#10;', '')) + 1"/>
				</xsl:variable>  
				<xsl:text disable-output-escaping="yes">&lt;Row ss:Height="</xsl:text><xsl:value-of select="12.75*$number_of_CRLF_in_Constraints"/><xsl:text disable-output-escaping="yes">" ss:StyleID="s30LeftUABSTYLE"&gt;</xsl:text>
				<!--First column: AttributeFamily-->
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="LeftUABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:value-of select="ancestor::AttributeFamily/AttributeFamilyName"/>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End first column: AttributeFamily-->
				<!--Second column: AttributeName-->
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="LeftUABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:choose>
					<xsl:when test="count(ancestor::Attribute/AttributeName)>0">
						<xsl:choose>
							<xsl:when test="count(ancestor::Attribute/isSpecificationAttribute/NameRepresentation)>0">
								<xsl:value-of select="ancestor::Attribute/isSpecificationAttribute/NameRepresentation"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="ancestor::Attribute/AttributeName"/>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:text disable-output-escaping="yes">::</xsl:text>
					</xsl:when>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/NameRepresentation)>0">
						<xsl:value-of select="isSpecificationAttribute/NameRepresentation"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="AttributeName"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End second column: AttributeName-->
				<!--Third column: HelpCategory-->
				<xsl:text disable-output-escaping="yes">&lt;Cell&gt;&lt;Data ss:Type="String"&gt;Constraints</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End third column: HelpCategory-->
				<!--Fourth column: HelpDescription-->
				<xsl:text disable-output-escaping="yes">&lt;Cell&gt;&lt;Data ss:Type="String"&gt;&lt;![CDATA[</xsl:text>
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/Constraints)>0">
						<xsl:value-of disable-output-escaping="yes" select="isSpecificationAttribute/Constraints"/>
					</xsl:when>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">]]&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
				<!--End fourth column: HelpDescription-->
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;&#10;</xsl:text>

			</xsl:for-each>
		</xsl:for-each>
		<xsl:text disable-output-escaping="yes">
		&lt;/Table&gt;
  &lt;WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel"&gt;
   &lt;Print&gt;
    &lt;ValidPrinterInfo/&gt;
    &lt;PaperSizeIndex&gt;9&lt;/PaperSizeIndex&gt;
    &lt;HorizontalResolution&gt;600&lt;/HorizontalResolution&gt;
    &lt;VerticalResolution&gt;600&lt;/VerticalResolution&gt;
   &lt;/Print&gt;
   &lt;Zoom&gt;75&lt;/Zoom&gt;
   &lt;Selected/&gt;
   &lt;FreezePanes/&gt;
   &lt;FrozenNoSplit/&gt;
   &lt;SplitHorizontal&gt;1&lt;/SplitHorizontal&gt;<!--Hard-code horizontal split after row 1-->
   &lt;TopRowBottomPane&gt;1&lt;/TopRowBottomPane&gt;
   &lt;SplitVertical&gt;2&lt;/SplitVertical&gt; <!--Hard-code vertical split after column 2-->
   &lt;LeftColumnRightPane&gt;2&lt;/LeftColumnRightPane&gt;
   &lt;ActivePane&gt;0&lt;/ActivePane&gt;
   &lt;Panes&gt;
    &lt;Pane&gt;
     &lt;Number&gt;3&lt;/Number&gt;
     &lt;ActiveRow&gt;22&lt;/ActiveRow&gt;
     &lt;ActiveCol&gt;5&lt;/ActiveCol&gt;
    &lt;/Pane&gt;
   &lt;/Panes&gt;
   &lt;ProtectObjects&gt;False&lt;/ProtectObjects&gt;
   &lt;ProtectScenarios&gt;False&lt;/ProtectScenarios&gt;
   &lt;AllowSizeCols/&gt;
   &lt;AllowSizeRows/&gt;
   &lt;AllowInsertHyperlinks/&gt;
   &lt;AllowSort/&gt;
   &lt;AllowFilter/&gt;
   &lt;AllowFormatCells/&gt;
   &lt;/WorksheetOptions&gt;
  </xsl:text>
  
	<!-- Create AutoFilter for all cells from the first cell of data down (because with protected sheets the user can't enable this feature so make it enabled by default) -->
  <xsl:text disable-output-escaping="yes">
   &lt;x:AutoFilter x:Range="R1C1:R1C4"
   xmlns="urn:schemas-microsoft-com:office:excel"&gt;
   &lt;/x:AutoFilter&gt;
   </xsl:text>

<!-- Add conditional formatting to allow the user to distinguish from one another -->
<xsl:variable name="numSpecAttributes" select="count(.//Attribute[count(.//Attribute)=0][count(isSpecificationAttribute)>0] )"/>
<xsl:text disable-output-escaping="yes"><![CDATA[  <ConditionalFormatting xmlns="urn:schemas-microsoft-com:office:excel">
   <Range>R2C3:R]]></xsl:text>
<xsl:value-of select="1 + $numSpecAttributes*4"/>
<xsl:text disable-output-escaping="yes"><![CDATA[C4</Range>
   <Condition>
    <Value1>ISEVEN(ROUNDDOWN((ROW()-2)/4,0))</Value1>
    <Format Style='background:#BFBFBF'/>
   </Condition>
  </ConditionalFormatting>
]]></xsl:text>

<xsl:text disable-output-escaping="yes">  
 &lt;/Worksheet&gt;
&lt;/Workbook&gt;
	</xsl:text>	 
	
	</xsl:template>
</xsl:stylesheet>


    