package org.xdv.xpath;

/**
 * XPath expression.
 * <p>
 * It can be a precompiled expression or a simple text wrapper - it depends on implementation.
 * Instance should be created using {@link XPathEngine#createExpression(String)}.
 * </p>
 * 
 * @author Tomasz Kokoszka
 */
public interface XPathExpression {

    /**
     * Returns wrapped xpath expression as a text.
     * @return XPath expression as a text; !=null.
     *         For instance <code>/data/field[substring(@name, 1, 2)='In']</code> 
     */
    public String asString();   

}
